<?php
/**
 * 微动CMS
 * ============================================================================
 * * 版权所有 青岛微动一百网络科技有限公司，并保留所有权利。
 * 网站地址: http://bbs.weidong100.com
 * ----------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在不用于商业目的的前提下对程序代码进行修改和
 * 使用；不允许对程序代码以任何形式任何目的的再发布。
 * ============================================================================
 * 更多系统：shopNR本地电商系统、微速卖-云外卖系统
 * 
*/
class AdminAction extends Action
{

    public function _initialize()
    {
        C('DEFAULT_THEME','admin'); 
        header("Content-Type:text/html; charset=utf-8");
        if (ACTION_NAME != 'login' && ACTION_NAME != 'logout' && ACTION_NAME != 'verifycode') {
            if (! session('?admin') || ! session('?brower')) {
                header("Location: ".U('login'));
                exit();
            } elseif (session('brower') != md5($_SERVER['HTTP_USER_AGENT'] . $_SERVER['REMOTE_ADDR'])) {
                redirect(U('logout', 3, '检测到异常，请您重新登录！正在跳转...'));
            }
        }
    }

    public function index()
    {
        $Slide = M('Slide');
        $Article = M('Article');
        $Photo = M('Photo');
        $Video = M('Video');
        $Page = M('Page');
        $Cus = M('Cus');
        $Link = M('Link');
        $num['slide']=$Slide->where(array('is_mobile'=>'0'))->count();
        $num['slide_m']=$Slide->where(array('is_mobile'=>'1'))->count();
        $num['article']= $Article->count();
        $num['photos']=$Photo->where(array('category'=>'0'))->count();
        $num['photo']=$Photo->where(array('category'=>array('neq','0')))->count();
        $num['video']= $Video->count();
        $num['page']= $Page->count();
        $num['cus']= $Cus->count();
        $num['link']= $Link->count();
        $this->assign('sunnum',$num);
        
        $this->display();
    }

    /**
     * 幻灯片管理
     */
    public function slide()
    {
        $Slide = M('Slide');
        if (IS_POST) {
            // 修改或者新增处理
            if (I('post.slide_id')) {
                // 修改处理
                if (! PosInt(I('post.slide_id'))) {
                    $this->error('参数错误！[s01]');
                    exit;
                }
                if ($slidedata = $Slide->where('slide_id=' . I('post.slide_id'))->find()) {
                    
                } else {
                    $this->error('参数错误！[s02]');
                     exit;
                }
                
                if (I('post.title') == '') {
                    $this->error('标题不能为空！');
                     exit;
                }
                
                
                if (strlen(I('post.title')) > 60) {
                    $this->error('标题字数超过限制！');
                }
                
                if ((I('post.imgurl1') == '')) {
                    $this->error('参数错误！[s03]');
                     exit;
                }

                if ($_FILES['imgurl']['name'] != '') {
                    // 上传了新文件处理
                    if ($image = $Slide->where(array(
                        'slide_id' => I('post.slide_id')
                    ))->find()) {
                        // 查询原文件
                        // 文件上传
                        $upload_path = 'Slide';
                        
                        $data['image_url'] = $this->upload($upload_path);
                        unlink('./Public/Cms/Slide/' . $image['image_url']); // 删除原文件
                    } else {
                        $this->error('参数错误！');
                         exit;
                    }
                } else {
                    // 未上传，不处理
                }
                
                $data['title'] = I('post.title');
                $data['sort'] = I('post.sort');
                $data['url'] = I('post.url');
                $data['is_mobile'] = I('post.is_mobile');
                // dump($data);
                if ($Slide->where('slide_id=' . I('post.slide_id'))
                    ->data($data)
                    ->save()) {
                    $this->success('幻灯片修改成功！');
                     exit;
                } else {
                    $this->error('幻灯片修改失败！');
                     exit;
                }
                // 修改处理 end
            } else {
                // 新增处理
                
                if (I('post.title') == '' || I('post.url') == '' ) {
                    $this->error('表单内容不能为空！');
                     exit;
                }
                if ($_FILES['imgurl']['name'] == '') {
                    $this->error('请上传文件！');
                     exit;
                }
                if (! Url(I('post.url'))) {
                    $this->error('URL格式不正确，请检查！');
                     exit;
                }
                
                // 文件上传
                $upload_path = 'Slide';
                $data['image_url'] = $this->upload($upload_path);
                // 上传 end
                $data['title'] = I('post.title');
                $data['url'] = I('post.url');
                $data['sort'] = I('post.sort');
                 $data['is_mobile'] = I('post.is_mobile');
                if ($Slide->data($data)->add()) {
                    $this->success('新增幻灯片成功！');
                     exit;
                } else {
                    $this->error('新增幻灯片失败！');
                     exit;
                }
                
                // 新增处理 end
            }
        } else {
            // 输出界面或者回调或者删除
            if (I('get.id')) {
                // 回调数据或者删除
                if (I('get.oper') == 'delete') {
                    // 删除操作
                    if (! PosInt(I('get.id'))) {
                        echo 'error';
                        exit();
                       
                    }
                    if ($image = $Slide->where('slide_id=' . I('get.id'))->find()) {
                        // 查询成功，删除
                        if ($Slide->where('slide_id="' . I('get.id') . '"')->delete()) {
                            unlink('./Public/Cms/Slide/' . $image['image_url']);
                            echo 'ok';
                            // $this->success('删除幻灯片成功！');
                        } else {
                            echo 'fail';
                            exit();
                            // $this->error('删除幻灯片失败！');
                        }
                    } else {
                        echo 'select_fail';
                        exit();
                        // $this->error('查询失败！');
                    }
                } elseif (I('get.oper') == 'getjs') {
                    //http://cms.weidong100.com/index.php?m=Admin&a=slide&oper=getjs&id=17
                    if ($json = $Slide->where(array(
                        'slide_id' => I('get.id')
                    ))->find()) {
                        echo json_encode($json);
                    } else {
                        echo '{"":""}';
                    }
                    // 回调操作
                } else {
                    $this->error('参数错误！');
                    exit;
                }
            } else {
                // 分页输出
                
               /* 2015年10月9日 09:37:17 废弃
               $listpage = $this->getpage($Slide, 'sort');*/
                
                import('ORG.Util.Page');
                $count  = $Slide->count();
                $Page  = new Page($count,10);
                $Page->setConfig('header',"个幻灯片");
                $show   = $Page->show();
                $list = $Slide->order('is_mobile desc,sort desc')->limit($Page->firstRow.','.$Page->listRows)->select();
                $this->assign('list', $list); // 赋值
                $this->assign('page', $show);
                
                
                /*2015年10月9日 09:36:42 废弃 董永赛
                $this->assign('list', $listpage[0]); // 赋值数据集
                $this->assign('page', $listpage[1]);*/
                
                // 输出 end
                $this->display();
            }
        }
    }

    /**
     * 导航栏管理
     */
    public function nav()
    {
        $Nav = M('Nav');
        if (IS_POST) {
            // 新增或修改操作
            if (I('post.id')) {
                // 修改操作
                if (! PosInt(I('post.id'))) {
                    $this->error('参数有误！');
                    exit;
                }
                if (I('post.title') == '' || I('post.url') == '' || I('post.sort') == '' || I('post.parent_id') == '') {
                    $this->error('所填内容不能为空！');
                    exit;
                }
                if (strlen(I('post.title')) > 45) {
                    $this->error('字数不能超过15字！');
                    exit;
                }
                //2015年09月16日11:50:4 验证方式有误 删除 董永赛
                /*if (! Url(I('post.url'))) {
                     $this->error('导航链接输入有误！');
                }*/
                if (! PosInt(I('post.sort'))) {
                    $this->error('排序只能输入正整数！');
                    exit;
                }
                
                // 验证提交的父级导航存在性
                $parent_data = $Nav->where('parent_id=0')->select();
                $n = 0;
                foreach ($parent_data as $key => $value) {
                    if ($value['nav_id'] == I('post.parent_id')) {
                        $n ++;
                    }
                }
                if (($n != 1) && (I('post.parent_id') != '0')) {
                    $this->error('父级导航选择错误！');
                    exit;
                }
                // 验证 end
                
                $data['title'] = I('post.title');
                $data['url'] = $_POST['url'];
                $data['sort'] = I('post.sort');
                $data['parent_id'] = I('post.parent_id');
                if ($Nav->where('nav_id=' . I('post.id'))
                    ->data($data)
                    ->save()) {
                    $this->success('修改导航成功！');
                    exit;
                } else {
                    $this->error('修改导航失败！');
                    exit;
                }
            } else {
                // 新增操作
                if (I('post.title') == '' || I('post.url') == '' || I('post.sort') == '' || I('post.parent_id') == '') {
                    $this->error('所填内容不能为空！');
                    exit;
                }
                if (strlen(I('post.title')) > 45) {
                    $this->error('字数不能超过15字！');
                    exit;
                }
                //2015年09月16日11:51:19 验证方式有误 删 董永赛
                /*if (! Url(I('post.url'))) {
                    $this->error('导航链接输入有误！');
                }*/
                if (! PosInt(I('post.sort'))) {
                    $this->error('排序只能输入正整数！');
                    exit;
                }
                
                // 验证提交的父级导航存在性
                $parent_data = $Nav->where('parent_id=0')->select();
                $n = 0;
                foreach ($parent_data as $key => $value) {
                    if ($value['nav_id'] == I('post.parent_id')) {
                        $n ++;
                    }
                }
                if (($n != 1) && (I('post.parent_id') != '0')) {
                    $this->error('父级导航选择错误！');
                    exit;
                }
                // 验证 end
                
                $data['title'] = I('post.title');
                $data['url'] =  $_POST['url'];
                $data['sort'] = I('post.sort');
                $data['parent_id'] = I('post.parent_id');
                if ($Nav->data($data)->add()) {
                    $this->success('新增导航成功！');
                    exit;
                } else {
                    $this->error('新增导航失败！');
                    exit;
                }
                
                // 新增 end
            }
        } else {
            // 删除、回调、输出
            if (I('get.id')) {
                // 删除或回调
                if (! PosInt(I('get.id'))) {
                    $this->error('参数错误！');
                    exit;
                }
                if (I('get.oper') == 'getjs') {
                    // 异步请求
                    if ($json = $Nav->where(array(
                        'nav_id' => I('get.id')
                    ))->find()) {
                        echo json_encode($json);
                    } else {
                        echo '{"":""}';
                    }
                } elseif (I('get.oper') == 'delete') {
                    // 删除操作
                    if ($Nav->where(array(
                        'parent_id' => I('get.id')
                    ))->find()) {
                        $this->error('此栏目下还有内容，无法删除！');
                        exit;
                    } else {
                        if ($Nav->where(array(
                            'nav_id' => I('get.id')
                        ))->delete()) {
                            $this->success('删除导航成功！');
                            exit;
                        } else {
                            $this->error('删除失败！');
                            exit;
                        }
                    }
                } else {
                    $this->error('参数错误！');
                    exit;
                }
                
                // end
            } else {
                // 输出内容
               
                // 输出 end
              
                $parent_data = $Nav->order('`sort` desc')->select();
                foreach($parent_data as $k=>$v){
                    if($v['parent_id']==0){
                        $list[]=$v;
                        
                    }else{
                        $l2[$v['parent_id']][]=$v;
                        
                    }
                } 
                
                foreach( $list as $k1=>$v1){
                   foreach($l2 as $k3=>$v3){
                       if($v1['nav_id']==$k3){
                            $list[$k1]['children']=$l2[$k3];
                        }
                   }
                }
                $this->assign('list', $list);
                // 编辑框父级数据输出
                $parent_data = $Nav->where('parent_id=0')->select();
                $this->assign('parent_data', $parent_data);
                
           
                
                // 输出完毕
                $this->display();
            }
        }
    }

    /**
     * 文章分类管理
     */
    public function cate()
    {
        $Cate = M('Cate');
        if (IS_POST) {
            // 新增或修改操作
            if (I('post.id')) {
                // 修改操作
                if (! PosInt(I('post.id'))) {
                    $this->error('参数有误！');
                    exit;
                }
                if (I('post.title') == '' || I('post.parent_id') == '') {
                    $this->error('所填内容不能为空！');
                    exit;
                }
                if (strlen(I('post.title')) > 30) {
                    $this->error('字数不能超过10字！');
                    exit;
                }
                
                // 验证提交的父级导航存在性
                $parent_data = $Cate->where('parent_id=0')->select();
                $n = 0;
                foreach ($parent_data as $key => $value) {
                    if ($value['cate_id'] == I('post.parent_id')) {
                        $n ++;
                    }
                }
                if (($n != 1) && (I('post.parent_id') != '0')) {
                    $this->error('父级分类数据错误！');
                    exit;
                }
                // 验证 end
                
                $data['title'] = I('post.title');
                $data['sort'] = I('post.sort');
                $data['parent_id'] = I('post.parent_id');
                
            
                if ($Cate->where('cate_id=' . I('post.id'))
                    ->data($data)
                    ->save()) {
                    $this->success('修改分类成功！');
                    exit;
                } else {
                    $this->error('修改分类失败！');
                    exit;
                }
            } else {
                // 新增操作
                if (I('post.title') == '' || I('post.parent_id') == '') {
                    $this->error('所填内容不能为空！');
                    exit;
                }
                if (strlen(I('post.title')) > 30) {
                    $this->error('字数不能超过10字！');
                    exit;
                }
                
                // 验证提交的父级导航存在性
                $parent_data = $Cate->where('parent_id=0')->select();
                $n = 0;
                foreach ($parent_data as $key => $value) {
                    if ($value['cate_id'] == I('post.parent_id')) {
                        $n ++;
                    }
                }
                if (($n != 1) && (I('post.parent_id') != '0')) {
                    $this->error('父级分类数据错误！');
                    exit;
                }
                // 验证 end
                
                $data['title'] = I('post.title');
                $data['sort'] = I('post.sort');
                $data['parent_id'] = I('post.parent_id');
               
                if ($Cate->data($data)->add()) {
                    $this->success('新增分类成功！');
                    exit;
                } else {
                    $this->error('新增分类失败！');
                    exit;
                }
                
                // 新增 end
            }
        } else {
            // 删除、回调、输出
            if (I('get.id')) {
                // 删除或回调
                if (! PosInt(I('get.id'))) {
                    $this->error('参数错误！');
                    exit;
                }
                if (I('get.oper') == 'getjs') {
                    // 异步请求
                    if ($json = $Cate->where(array(
                        'cate_id' => I('get.id')
                    ))->find()) {
                        echo json_encode($json);
                    } else {
                        echo '{"":""}';
                    }
                } elseif (I('get.oper') == 'delete') {
                    // 删除操作
                    if ($Cate->where(array('parent_id' => I('get.id')))->find()) {
                        $this->error('此栏目下还有内容，无法删除！');
                        exit;
                    } else {
                       
                        $Article = M('Article');
                        if($Article ->where(array('cate' => I('get.id')))->find()){
                             $this->error('此栏目下还有内容，无法删除！');
                             exit;
                        }
                        if ($Cate->where(array(
                            'cate_id' => I('get.id')
                        ))->delete()) {
                            $this->success('删除分类成功！');
                            exit;
                        } else {
                            $this->error('删除失败！');
                            exit;
                        }
                    }
                } else {
                    $this->error('参数错误！');
                    exit;
                }
                
                // end
            } else {
                // 分页输出
                $listdata = $Cate ->order('sort desc')->select();
                foreach($listdata as $k=>$v){
                    if($v['parent_id']==0){
                        $list[]=$v;
                        
                    }else{
                        $l2[$v['parent_id']][]=$v;
                        
                    }
                }

                foreach( $list as $k1=>$v1){
                   foreach($l2 as $k3=>$v3){
    
                       if($v1['cate_id']==$k3){
                            $list[$k1]['children']=$l2[$k3];
                        }
                   }
                }
              
                $this->assign('list', $list);
                // 输出 end
                // 编辑框父级数据输出
                $parent_data = $Cate->where('parent_id=0')->select();
                $this->assign('parent_data', $parent_data);
                // 输出完毕
                $this->display();
            }
        }
    }

    /**
     * 文章列表
     */
    public function articlelist()
    {
        $Article = M('Article');
		if($_GET['cate_id']){
		   $map['cate']  = array('eq',$_GET['cate_id']);
	    }else{
	       $map['cate']  = array('neq','');
	    }
		import('ORG.Util.Page');
	    $count  = $Article->where($map)->count();
	    $Page  = new Page($count,20);
	    $Page->setConfig('header','篇文章');
	    $show   = $Page->show();
	    $list = $Article->where($map)->order('time desc')->limit($Page->firstRow.','.$Page->listRows)->select();
        $this->assign('list', $list); // 赋值
        $this->assign('page', $show);
        
        $this->display();
    }

    /**
     * 文章编辑
     */
    public function article()
    {
        date_default_timezone_set("PRC"); // 设置中国时区
        $Article = M('Article');
        
        // 有数据提交
        if (IS_POST) {
            // 新增或者修改处理
            if (I('post.id')) {
                // 修改处理
                
                if (! PosInt(I('post.id'))) {
                    $this->error('参数错误！[001]');
                    exit;
                }
                
                if ((I('post.title') == '') || (I('post.cate') == '') || (I('post.content') == '') ) {
                    $this->error('内容不能为空！');
                    exit;
                }
                if (strlen(I('post.title')) > 300) {
                    $this->error('标题字数超过限制！');
                    exit;
                }
                if (! PosInt(I('post.cate'))) {
                    $this->error('分类选择错误！');
                    exit;
                }
                // 2015年09月15日13:04:5 董永赛修改 附加修改上下文分类相关代码
                // 判断分类存在 start
                $Cate = M('Cate');
                $date = $Cate->where(array('cate_id' => I('post.cate')))->find();
                if (! $date) {
                    $this->error('分类不存在！');
                    exit();
                }
                // 判断分类存在 end
                $data['title'] = I('post.title');
                $data['cate'] = I('post.cate');
                $data['seo_keywords'] = I('post.seo_keywords');
                $data['seo_description'] = I('post.seo_description');
                $data['content'] = I('post.content', '', false);
                $data['sort'] = I('post.sort');
                if ($Article->where(array(
                    'article_id' => I('post.id')
                ))
                    ->data($data)
                    ->save()) {
                    $this->success('修改文章成功！', U('Admin/articlelist'));
                    exit;
                } else {
                    $this->error('修改文章失败！');
                    exit;
                }
                
                // 修改 end
            } else {
                // 新增处理
                
                if ((I('post.title') == '') || (I('post.cate') == '') || (I('post.content') == '' )) {
                    $this->error('内容不能为空！');
                    exit;
                }
                if (strlen(I('post.title')) > 300) {
                    $this->error('标题字数超过限制！');
                    exit;
                }
                if (! PosInt(I('post.cate'))) {
                    $this->error('分类选择错误！');
                    exit;
                }
                // 2015年09月15日13:05:31 董永赛修改 附加修改上下文分类相关代码
                // 判断分类存在 start
                $Cate = M('Cate');
                $date = $Cate->where(array(
                    'cate_id' => I('post.cate')
                ))->find();
                if (! $date) {
                    $this->error('分类不存在！');
                    exit();
                }
                // 判断分类存在 end
        
                
                $data['title'] = I('post.title');
                $data['cate'] = I('post.cate');
                $data['seo_keywords'] = I('post.seo_keywords');
                $data['seo_description'] = I('post.seo_description');
                $data['content'] = I('post.content', '', false);
                $data['sort'] = I('post.sort');
                $data['time'] = time();
                $data['number'] = 0;
                if ($Article->data($data)->add()) {
                    $this->success('添加文章成功！', U('Admin/articlelist'));
                    exit;
                } else {
                    $this->error('添加文章失败！');
                    exit;
                }
                
                // 新增 end
            }
        } elseif (I('get.id')) {
            // 修改界面
            
            if (! PosInt(I('get.id'))) {
                $this->error('参数错误！[002]');
                exit;
            }
            
            if ($g = $Article->where(array(
                'article_id' => I('get.id')
            ))->find()) {
                $this->assign('g', $g);
            } else {
                $this->error('参数错误！[003]');
                exit;
            }
            
            $Cate = M('Cate');
            $cate_data = $Cate->order('sort desc')->select();
            $cdata = $this->cate_data($cate_data);
            $this->assign('cate_data', $cdata);
            
            $this->display();
        } else {
            // 新增界面
            // 文章遍历分类
            $Cate = M('Cate');
            $cate_data = $Cate->order('sort desc')->select();
            $cdata = $this->cate_data($cate_data);
            
            $this->assign('cate_data', $cdata);
            $this->display();
        }
    }
    
    // 列表拼接输入sql结果,返回拼接好的分类列表
    public function cate_data($article_cate)
    {
        foreach ($article_cate as $k => $v) {
            if ($v['parent_id'] != 0) {
                
                $data[$v['parent_id']]['sub'][] = $v;
            } else {
                $data[$k] = $v;
            }
        }
        
        foreach ($data as $kk => $vv) {
            if (! is_array($vv['sub'])) {
                $data[$kk]['sub'] = $data[$vv['cate_id']]['sub'];
                unset($data[$vv['cate_id']]);
            }
        }
        return $data;
    }

    /**
     * 文章删除
     */
    public function article_del()
    {
        $Article = M('Article');
        if (I('get.id')) {
            if (! PosInt(I('get.id'))) {
                $this->error('参数有误！');
                exit;
            }
            if ($Article->where(array(
                'article_id' => I('get.id')
            ))->delete()) {
                $this->success('删除文章成功！');
                exit;
            } else {
                $this->error('删除文章失败！');
                exit;
            }
        } elseif(I('post.delg')) {
            //批量删除文章
            $arr=explode(",",$_POST['delg']);
		    foreach($arr as $key=>$value){
    			if($value){
    				
    				if($Article->where(array('article_id' => $value))->delete()){
    				  
    				}else{
    				  $this->error('有文章删除失败');
    				  exit;
    				} 
    			}
		    }
		    $this->success('删除成功');
		    exit;
        }else{
            $this->error('参数错误！');
            exit;
        }
    }

    /**
     * 文章分类二级联动回调接口
     */
    public function getarticle()
    {
        if (I('get.id')) {
            if (! PosInt(I('get.id'))) {
                echo '{"error":"error"}';
                exit();
            }
            $Cate = M('Cate');
            if ($result = $Cate->where('parent_id=' . I('get.id'))->select()) {
                echo json_encode($result);
            } else {
                die('{"error":"error"}');
            }
        } else {
            echo '{"":""}';
        }
    }

    /**
     * 相片管理
     */
    public function photo()
    {
        $Photo = M('Photo');
        //  dump($_POST);
        
        if (IS_POST) {
            // 修改或者新增处理
            if (I('post.id')) {
                // 修改处理
                
                if (! PosInt(I('post.id'))) {
                    $this->error('参数错误！');
                    exit;
                }
                if (! PosInt(I('post.pid'))) {
                    $this->error('参数错误！');
                    exit;
                }
                if ($pid_ver = $Photo->where('photo_id=' . I('post.id'))->find()) {
                    if ($pid_ver['category'] != I('post.pid')) {
                        $this->error('发生错误，请检查！');
                        exit;
                    }
                } else {
                    $this->error('参数错误！');
                    exit;
                }
                
                if (I('post.title') == '') {
                    $this->error('标题不能为空！');
                    exit;
                }
                
                if (strlen(I('post.title')) > 60) {
                    $this->error('标题字数超过限制！');
                    exit;
                }
                
                if ((I('post.imgurl1') == '')) {
                    $this->error('参数错误！');
                    exit;
                }

                if ($_FILES['imgurl']['name'] != '') {
                    // 上传了新文件处理
                    if ($image = $Photo->where(array(
                        'photo_id' => I('post.id')
                    ))->find()) {
                        // 查询原文件
                        // 文件上传
                        $upload_path = 'Photo';
                        
                        $data['image_url'] = $this->upload($upload_path);
                        unlink('./Public/Cms/Photo/' . $image['image_url']); // 删除原文件
                    } else {
                        $this->error('参数错误！');
                        exit;
                    }
                } else {
                    // 未上传，不处理
                }
                
                $data['title'] = I('post.title');
                $data['sort'] = I('post.sort');
                $data['category'] = I('post.pid');
                $data['parent_id'] = I('post.parent_id');
                $data['is_recommend'] = I('post.is_recommend');
                
                if ($Photo->where('photo_id=' . I('post.id'))
                    ->data($data)
                    ->save()) {
                    $this->success('相片修改成功！');
                    exit;
                } else {
                    $this->error('相片修改失败！');
                    exit;
                }
                
                // 修改处理 end
            } elseif(I('post.delg')){
                 //批量删除相片
                $arr=explode(",",$_POST['delg']);
    		    foreach($arr as $key=>$value){
        			if($value){
        				 if ($image = $Photo->where('photo_id=' . $value)->find()) {
                         $cid=$Photo->where(array('photo_id'=>$value))->getField('category');
                           
                            // 查询成功，删除
                            if ($Photo->where('photo_id="' .$value. '"')->delete()) {
                                unlink('./Public/Cms/Photo/' . $image['image_url']);
                                $Photo->where(array('photo_id'=>$cid))->setDec('number'); 
                               
                            } else {
                                $this->error('删除相片失败！');
                                exit;
                            }
                        } else {
                            $this->error('查询失败！');
                            exit;
                        }
        			}
    		    }
    		    $this->success('删除成功');
    		    exit;
            } else {
                // 新增处理
                
                $typeArr = array("jpg", "png", "gif");//允许上传文件格式 
                $path = "Public/Cms/Photo/";//上传路径 
                 
                if (isset($_POST)) { 
                    $name = $_FILES['file']['name']; 
                    $size = $_FILES['file']['size']; 
                    $name_tmp = $_FILES['file']['tmp_name']; 
                    if (empty($name)) { 
                        echo json_encode(array("error"=>"您还未选择图片")); 
                        exit; 
                    } 
                    $type = strtolower(substr(strrchr($name, '.'), 1)); //获取文件类型 
                     
                    if (!in_array($type, $typeArr)) { 
                        echo json_encode(array("error"=>"请上传jpg,png或gif类型的图片！")); 
                        exit; 
                    } 
                    if ($size > (500 * 1024)) { 
                        echo json_encode(array("error"=>"图片大小已超过500KB！")); 
                        exit; 
                    } 
                     
                    $pic_name = time() . rand(10000, 99999) . "." . $type;//图片名称 
                    $pic_url = $path . $pic_name;//上传后图片路径+名称 
                    if (move_uploaded_file($name_tmp, $pic_url)) { //临时文件转移到目标文件夹 
                        //写入数据库
                        // 上传 end
                        $data['image_url'] = $pic_name;
                        $data['category'] = I('get.pid');
                        $photo_id = $Photo->data($data)->add();
                        if ($photo_id) {
                            $Photo->where(array('photo_id'=>I('get.pid')))->setInc('number'); 
                            echo json_encode(array("error"=>"0","pic"=>$pic_name,"name"=>$pic_name,"photo_id"=>$photo_id)); 
                        } else {
                            echo json_encode(array("error"=>"上传有误，清检查服务器配置！")); 
                        }
                        
                    } else { 
                        echo json_encode(array("error"=>"上传有误，清检查服务器配置！")); 
                    } 
                }
                
                // 新增处理 end
            }
        } else {
            // 输出界面或者回调或者删除
            if (I('get.id')) {
                // 回调数据或者删除
                if (! PosInt(I('get.id'))) {
                    $this->error('参数错误！');
                    exit;
                }
                if (I('get.oper') == 'delete') {
                    // 删除操作
                   
                    if ($image = $Photo->where('photo_id=' . I('get.id'))->find()) {
                     $cid=$Photo->where(array('photo_id'=>I('get.id')))->getField('category');
                       
                        // 查询成功，删除
                        if ($Photo->where('photo_id="' . I('get.id') . '"')->delete()) {
                            unlink('./Public/Cms/Photo/' . $image['image_url']);
                            $Photo->where(array('photo_id'=>$cid))->setDec('number'); 
                            $this->success('删除相片成功！');
                            exit;
                        } else {
                            $this->error('删除相片失败！');
                            exit;
                        }
                    } else {
                        $this->error('查询失败！');
                        exit;
                    }
                   
                   
                } elseif (I('get.oper') == 'getjs') {
                    // 回调操作
                    if ($result = $Photo->where('photo_id=' . I('get.id'))->find()) {
                        echo json_encode($result);
                    } else {
                        $error_js = array(
                            'error' => 'error'
                        );
                        echo json_encode($error_js);
                    }
                } else {
                    $this->error('参数错误！');
                    exit;
                    
                }
            }else {
                // 分页输出
                if (I('get.pid')) {
                    if (! PosInt(I('get.pid'))) {
                        $this->error('参数错误！');
                        exit;
                    }
                    $map['category']  = array('eq',I('get.pid'));
                    import('ORG.Util.Page');
            	    $count  = $Photo->where($map)->count();
            	    $Page  = new Page($count,12);
            	    $Page->setConfig('header','篇图片');
            	    $show   = $Page->show();
            	    $list = $Photo->where($map)->order('sort desc')->limit($Page->firstRow.','.$Page->listRows)->select();
                    $this->assign('list', $list); // 赋值
                    $this->assign('page', $show);
                    $this->assign('pid', I('get.pid'));
                    $this->display();
                } else {
                    $this->error('访问错误！');
                    exit;
                }
            }
        }
    }

    /**
     * 相册管理
     */
    public function photolist()
    {
        $Photo = M('Photo');
        if (IS_POST) {
            // 修改或者新增处理
            if (I('post.id')) {
                // 修改处理
                
                if (!PosInt(I('post.id'))) {
                    $this->error('参数错误！');
                    exit;
                }
                
                if (I('post.title') == '') {
                    $this->error('图片标题不能为空！');
                    exit;
                }
                
                if (strlen(I('post.title')) > 60) {
                    $this->error('标题字数超过限制！');
                    exit;
                }
                
                if ((I('post.imgurl1') == '')) {
                    $this->error('参数错误！');
                    exit;
                }

                if ($_FILES['imgurl']['name'] != '') {
                    // 上传了新文件处理
                    if ($image = $Photo->where(array('photo_id' => I('post.id')))->find()) {
                        // 查询原文件
                        // 文件上传
                        $upload_path = 'Photo';
                        $data['image_url'] = $this->upload($upload_path);
                        unlink('./Public/Cms/Photo/' . $image['image_url']); // 删除原文件
                    } else {
                        $this->error('参数错误！');
                        exit;
                    }
                } else {
                   
                    // 未上传，不处理
                }
                $data['is_recommend'] = I('post.is_recommend');
                $data['title'] = I('post.title');
                $data['sort'] = I('post.sort');
                $data['describe'] = I('post.describe');
                if ($Photo->where(array('photo_id'=>I('post.id')))->data($data)->save()) {
                    $this->success('相册修改成功！');
                    exit;
                } else {
                    $this->error('相册修改失败！');
                    exit;
                }
                
                // 修改处理 end
            } else {
                // 新增处理
                
                if (I('post.title') == '') {
                    $this->error('图片标题不能为空！');
                    exit;
                }
                if ($_FILES['imgurl']['name'] == '') {
                    $this->error('请上传文件！');
                    exit;
                }
                // 文件上传
                $upload_path = 'Photo';
                
                $data['image_url'] = $this->upload($upload_path);
                
                // 上传 end
                $data['title'] = I('post.title');
                $data['is_recommend'] = I('post.is_recommend');
                $data['sort'] = I('post.sort');
                $data['describe'] = I('post.describe');
                $data['category'] = 0;
                
                if ($Photo->data($data)->add()) {
                    $this->success('新增相册成功！');
                    exit;
                } else {
                    $this->error('新增相册失败！');
                    exit;
                }
                
                // 新增处理 end
            }
        } else {
            // 输出界面或者回调或者删除
            if (I('get.id')) {
                // 回调数据或者删除
                if (! PosInt(I('get.id'))) {
                    $this->error('参数错误！');
                    exit;
                }
                if (I('get.oper') == 'delete') {
                    // 删除操作
                    
                    if ($image = $Photo->where('photo_id=' . I('get.id'))->find()) {
                        // 查询成功，删除
                        if ($Photo->where('category=' . I('get.id'))->find()) {
                            $this->error('此相册下面有相片，请先删除照片！');
                            exit;
                        }
                        if ($Photo->where('photo_id="' . I('get.id') . '"')->delete()) {
                            unlink('./Public/Cms/Photo/' . $image['image_url']);
                            $this->success('删除相册成功！');
                            exit;
                        } else {
                            $this->error('删除相册失败！');
                            exit;
                        }
                    } else {
                        $this->error('查询失败！');
                        exit;
                    }
                } elseif (I('get.oper') == 'getjs') {
                    // 回调操作
                    if ($result = $Photo->where(array('photo_id'=> I('get.id')))->find()) {
                        echo json_encode($result);
                    } else {
                        $error_js = array(
                            'error' => 'error'
                        );
                        echo json_encode($error_js);
                    }
                } else {
                    $this->error('参数错误！');
                    exit;
                }
            } else {
                // 分页输出
                
                $map['category']  = array('eq',0);
                import('ORG.Util.Page');
        	    $count  = $Photo->where($map)->count();
        	    $Page  = new Page($count,24);
        	    $Page->setConfig('header','篇相册');
        	    $show   = $Page->show();
        	    $list = $Photo->where($map)->order('sort desc')->limit($Page->firstRow.','.$Page->listRows)->select();
                $this->assign('list', $list); // 赋值
                $this->assign('page', $show);
                // 输出 end
                $this->display();
            }
        }
    }


    /**
     * 视频列表管理
     */
    public function Videolist()
    {
        $Video = M('Video');
        if (IS_POST) {
            // 修改或者新增处理
            if (I('post.id')) {
                // 修改处理
                
                if (! PosInt(I('post.id'))) {
                    $this->error('参数错误！');
                    exit;
                }
                
                if (I('post.title') == '' || I('post.sort') == '' || I('post.duration')=='') {
                    $this->error('表单内容为空！');
                    exit;
                }
                
                if (strlen(I('post.title')) > 60) {
                    $this->error('标题字数超过限制！');
                    exit;
                }
                
                if ((I('post.imgurl1') == '')) {
                    $this->error('参数错误！');
                    exit;
                }
                
                if (! PosInt(I('post.sort'))) {
                    $this->error('排序必须输入正整数！');
                    exit;
                }
                if (! PosInt(I('post.duration'))) {
                    $this->error('视频时长错误！');
                    exit;
                }
                
                if ($_FILES['imgurl']['name'] != '') {
                    // 上传了新文件处理
                    if ($image = $Video->where(array(
                        'video_id' => I('post.id')
                    ))->find()) {
                        // 查询原文件
                        // 文件上传
                        $upload_path = 'Video';
                        
                        $data['image_url'] = $this->upload($upload_path);
                        unlink('./Public/Cms/Video/' . $image['image_url']); // 删除原文件
                    } else {
                        $this->error('参数错误！');
                        exit;
                    }
                } else {
                    // 未上传，不处理
                }
                
                $data['title'] = I('post.title');
                $data['sort'] = I('post.sort');
                $data['describe'] = I('post.describe');
                $data['duration'] = I('post.duration');
                $data['time'] = time();
                $data['url'] = $_POST['url'];
                
                $rd1=$Video->where(array('video_id'=> I('post.id')))->save($data);
                
                if ($rd1) 
                {
                    $this->success('视频修改成功！');
                    exit;
                } else {
                    $this->error('视频修改失败！');
                    exit;
                }
                
                // 修改处理 end
            } else {
                // 新增处理
                
                if (I('post.title') == '' || I('post.sort') == '') {
                    $this->error('表单内容不能为空！');
                    exit;
                }
                if ($_FILES['imgurl']['name'] == '') {
                    $this->error('请上传文件！');
                    exit;
                }
                if (! PosInt(I('post.sort'))) {
                    $this->error('排序必须输入正整数！');
                    exit;
                }
                
                // 文件上传
                $upload_path = 'Video';
                
                $data['image_url'] = $this->upload($upload_path);
                
                // 上传 end
                $data['title'] = I('post.title');
                $data['sort'] = I('post.sort');
                $data['url'] = $_POST['url'];
                $data['duration'] = I('post.duration');
                $data['time'] = time();
                if ($Video->data($data)->add()) {
                    $this->success('新增视频成功！');
                    exit;
                } else {
                    $this->error('新增视频失败！');
                    exit;
                }
                
                // 新增处理 end
            }
        } else {
            // 输出界面或者回调或者删除
            if (I('get.id')) {
                // 回调数据或者删除
                if (! PosInt(I('get.id'))) {
                    $this->error('参数错误！');
                    exit;
                }
                if (I('get.oper') == 'delete') {
                    // 删除操作
                    
                    if ($image = $Video->where('video_id=' . I('get.id'))->find()) {
                        // 查询成功，删除
                        if ($Video->where('video_id="' . I('get.id') . '"')->delete()) {
                            unlink('./Public/Cms/Video/' . $image['image_url']);
                            $this->success('删除视频成功！');
                            exit;
                        } else {
                            $this->error('删除视频失败！');
                            exit;
                        }
                    } else {
                        $this->error('查询失败！');
                        exit;
                    }
                } elseif (I('get.oper') == 'getjs') {
                    // 回调操作
                    if ($result = $Video->where('video_id=' . I('get.id'))->find()) {
                        echo json_encode($result);
                    } else {
                        $error_js = array(
                            'error' => 'error'
                        );
                        echo json_encode($error_js);
                    }
                } else {
                    $this->error('参数错误！');
                    exit;
                }
            } else {
                // 分页输出
                
                $map['category']  = array('eq',0);
                import('ORG.Util.Page');
        	    $count  = $Video->where($map)->count();
        	    $Page  = new Page($count,18);
        	    $Page->setConfig('header','个视频');
        	    $show   = $Page->show();
        	    $list = $Video->where($map)->order('sort desc')->limit($Page->firstRow.','.$Page->listRows)->select();
                $this->assign('list', $list); // 赋值
                $this->assign('page', $show);
                
                // 输出 end
                $this->display();
            }
        }
    }

    /**
     * 单页编辑列表
     */
    public function pagelist()
    {
        $Pagesql = M('Page');
       /* 2015年10月9日 09:11:21 被废弃 董永赛
       $listpage = $this->getpage($Pagesql);*/
     
        import('ORG.Util.Page');
        $count  = $Pagesql->count();
        $Page  = new Page($count,24);
        $Page->setConfig('header','篇文章');
        $show   = $Page->show();
        $list = $Pagesql->order('sort desc')->limit($Page->firstRow.','.$Page->listRows)->select();
        $this->assign('list', $list); // 赋值
        $this->assign('page', $show);
        
        $this->display();
    }

    /**
     * 单页编辑
     */
    public function page()
    {
        $Page = M('Page');
        if (IS_POST) {
            // 修改与新增
            if (I('post.id')) {
                // 修改操作
                if (! PosInt(I('post.id'))) {
                    $this->error('参数错误！');
                    exit;
                }
                if ((I('post.title') == '') || (I('post.content') == '')) {
                    $this->error('内容不能为空！');
                    exit;
                }
                if (strlen(I('post.title')) > 60) {
                    $this->error('标题字数超过限制！');
                    exit;
                }
                $data['title'] = I('post.title');
                $data['type'] = I('post.type');
                $data['sort'] = I('post.sort');
                $data['seo_keywords'] = I('post.seo_keywords');
                $data['seo_description'] = I('post.seo_description');
                $data['content'] = I('post.content', '', false);
                if ($Page->where('page_id=' . I('post.id'))->data($data)->save()) {
                    $this->success('修改页面成功！', U('Admin/pagelist'));
                    exit;
                } else {
                    $this->error('修改页面失败！');
                    exit;
                }
            } else {
                // 新增操作
                if ((I('post.title') == '') || (I('post.content') == '')) {
                    $this->error('内容不能为空！');
                    exit;
                }
                if (strlen(I('post.title')) > 60) {
                    $this->error('标题字数超过限制！');
                    exit;
                }
                $data['title'] = I('post.title');
                $data['type'] = I('post.type');
                $data['seo_keywords'] = I('post.seo_keywords');
                $data['seo_description'] = I('post.seo_description');
                $data['content'] = I('post.content', '', false);
                if ($Page->data($data)->add()) {
                    $this->success('添加页面成功！', U('Admin/pagelist'));
                    exit;
                } else {
                    $this->error('添加页面失败！');
                    exit;
                }
            }
        } elseif (I('get.id')) {
            // 修改界面
            if (! PosInt(I('get.id'))) {
                $this->error('参数错误！');
                exit;
            }
            if ($g = $Page->where('page_id=' . I('get.id'))->find()) {
                $this->assign('g', $g);
            } else {
                $this->error('页面不存在！');
                exit;
            }
            $this->display();
        } else {
            // 新增界面
            $this->display();
        }
    }

    /**
     * 删除单页
     */
    public function pagedel()
    {
        if (I('get.id')) {
            if (! PosInt(I('get.id'))) {
                $this->error('参数错误！');
                exit;
            }
            $Page = M('Page');
            if ($Page->where('page_id=' . I('get.id'))->delete()) {
                $this->success('删除单页面成功！');
                exit;
            } else {
                $this->error('删除单页面失败！');
                exit;
            }
        } else {
            $this->error('参数错误！');
            exit;
        }
    }

    /**
     * 客服管理列表
     */
    public function cuslist()
    {
        $Cus = M('Cus');
       /* 2015年10月9日 09:14:03 被废弃  董永赛
       $listpage = $this->getpage($Cus, 'sort');*/

        import('ORG.Util.Page');
        $count  = $Cus->count();
        $Page  = new Page($count,24);
        $Page->setConfig('header','个客服');
        $show   = $Page->show();
        $list = $Cus->order('sort desc')->limit($Page->firstRow.','.$Page->listRows)->select();
        $this->assign('list', $list); // 赋值
        $this->assign('page', $show);
        $this->display();
    }

    /**
     * 客服编辑
     */
    public function cus()
    {
        $Cus = M('Cus');
        if (IS_POST) {
            // 修改或新增操作
            if (I('post.id')) {
                // 修改操作
                if (! PosInt(I('post.id'))) {
                    $this->error('参数错误！');
                    exit;
                }
                if ((I('post.name') == '') || (I('post.qq') == '') || (I('post.sort') == '')) {
                    $this->error('内容不能为空！');
                    exit;
                }
                if (strlen(I('post.name')) > 45) {
                    $this->error('姓名超过长度！');
                    exit;
                }
                if (! qq(I('post.qq'))) {
                    $this->error('QQ号不符合要求！');
                    exit;
                }
                if (! PosInt(I('post.sort'))) {
                    $this->error('排序必须输入正整数！');
                    exit;
                }
                
                $data['name'] = I('post.name');
                $data['qq'] = I('post.qq');
                $data['sort'] = I('post.sort');
                
                if ($Cus->where('cus_id=' . I('post.id'))
                    ->data($data)
                    ->save()) {
                    $this->success('修改成功！', U('Admin/cuslist'));
                    exit;
                } else {
                    $this->error('修改失败！');
                    exit;
                }
            } else {
                // 新增操作
                if ((I('post.name') == '') || (I('post.qq') == '') || (I('post.sort') == '')) {
                    $this->error('内容不能为空！');
                    exit;
                }
                if (strlen(I('post.name')) > 45) {
                    $this->error('姓名超过长度！');
                    exit;
                }
                if (! qq(I('post.qq'))) {
                    $this->error('QQ号不符合要求！');
                    exit;
                }
                if (! PosInt(I('post.sort'))) {
                    $this->error('排序必须输入正整数！');
                    exit;
                }
                
                $data['name'] = I('post.name');
                $data['qq'] = I('post.qq');
                $data['sort'] = I('post.sort');
                
                if ($Cus->data($data)->add()) {
                    $this->success('新增客服成功！', U('Admin/cuslist'));
                    exit;
                } else {
                    $this->error('新增客服失败！');
                    exit;
                }
            }
        } elseif (I('get.id')) {
            // 修改界面
            if (! PosInt(I('get.id'))) {
                $this->error('参数错误！');
                exit;
            }
            
            if (I('get.oper') == 'getjs') {
                // 异步请求
                if ($json = $Cus->where(array(
                    'cus_id' => I('get.id')
                ))->find()) {
                    echo json_encode($json);
                    exit;
                } else {
                    echo '{"":""}';
                    exit;
                }
            }
            
            
            if ($g = $Cus->where('cus_id=' . I('get.id'))->find()) {
                $this->assign('g', $g);
            } else {
                $this->error('查询失败！');
                exit;
            }
        
            $this->display();
        } else {
            $this->display();
        }
    }

    /**
     * 删除客服
     */
    public function cusdel()
    {
        if (I('get.id')) {
            if (! PosInt(I('get.id'))) {
                $this->error('参数错误！');
                exit;
            }
            $Cus = M('Cus');
            if ($Cus->where('cus_id=' . I('get.id'))->delete()) {
                $this->success('客服删除成功！');
                exit;
            } else {
                $this->error('客服删除失败！');
                exit;
            }
        } else {
            $this->error('参数错误！');
            exit;
        }
    }

    /**
     * 友情链接管理
     */
    public function link()
    {
        $Link = M('Link');
        if (IS_POST) {
            // 修改或新增操作
            if (I('post.id')) {
                // 修改操作
                if (! PosInt(I('post.id'))) {
                    $this->error('参数错误！');
                    exit;
                }
                
                if ((I('post.title') == '') || (I('post.url') == '') || (I('post.sort') == '')) {
                    $this->error('填写内容不能为空！');
                    exit;
                }
                if (strlen(I('post.title')) > 60) {
                    $this->error('标题字数超过限制！');
                    exit;
                }
                if (! Url(I('post.url'))) {
                    $this->error('请输入正确的链接！');
                    exit;
                }
                if (! PosInt(I('post.sort'))) {
                    $this->error('排序必须输入正整数！');
                    exit;
                }
                
                $data = array(
                    'title' => I('post.title'),
                    'url' => I('post.url'),
                    'sort' => I('post.sort')
                );
                
                if ($Link->where('link_id=' . I('post.id'))
                    ->data($data)
                    ->save()) {
                    $this->success('修改友情链接成功！');
                    exit;
                } else {
                    $this->error('修改友情链接失败！');
                    exit;
                }
            } else {
                // 新增操作
                if ((I('post.title') == '') || (I('post.url') == '') || (I('post.sort') == '')) {
                    $this->error('填写内容不能为空！');
                    exit;
                }
                if (strlen(I('post.title')) > 60) {
                    $this->error('标题字数超过限制！');
                    exit;
                }
                if (! Url(I('post.url'))) {
                    $this->error('请输入正确的链接！');
                    exit;
                }
                if (! PosInt(I('post.sort'))) {
                    $this->error('排序必须输入正整数！');
                    exit;
                }
                
                $data = array(
                    'title' => I('post.title'),
                    'url' => I('post.url'),
                    'sort' => I('post.sort')
                );
                if ($Link->data($data)->add()) {
                    $this->success('新增友情链接成功！');
                    exit;
                } else {
                    $this->error('新增友情链接失败！');
                    exit;
                }
            }
        } elseif (I('get.id')) {
            // 删除或ajax请求
            if (! PosInt(I('get.id'))) {
                $this->error('参数错误！');
                exit;
            }
            if (I('get.oper') == 'delete') {
                // 删除操作
                if ($Link->where('link_id=' . I('get.id'))->delete()) {
                    $this->success('删除友情链接成功！');
                    exit;
                } else {
                    $this->error('删除友情链接失败！');
                    exit;
                }
            } elseif (I('get.oper') == 'getjs') {
                // Ajax请求
                if ($result = $Link->where('link_id=' . I('get.id'))->find()) {
                    echo json_encode($result);
                } else {
                    $error_js = array(
                        'error' => 'error'
                    );
                    echo json_encode($error_js);
                }
            }
        } else {
            // 列表输出
            import('ORG.Util.Page');
            $count  = $Link->where($map)->count();
            $Page  = new Page($count,24);
            $Page->setConfig('header','个客服');
            $show   = $Page->show();
            $list = $Link->order('sort desc')->limit($Page->firstRow.','.$Page->listRows)->select();
            $this->assign('list', $list); // 赋值
            $this->assign('page', $show);
           
            $this->display();
        }
    }

    /**
     * 站点设置
     */
    public function config()
    {
        $Config = D('Config');
        if (IS_POST) {
            // 修改
            $data = I('post.');
            $data['site_record'] = I('post.site_record', '', false); // 代码重新获取
            $data['site_password'] = md5(I('post.site_password'));
            $reslut = $Config->changeConfig($data);
            if ($reslut) {
                $this->success('修改成功！');
                exit;
            } else {
                $this->error('修改失败或未做更改！');
                exit;
            }
        } else {
            // 数据读取
            $config_data = $Config->select();
            $site = array();
            foreach ($config_data as $key => $value) {
                $site[$value['name']] = $value['value'];
            }
            $this->assign('site', $site);
            
            // 读取 end
            $this->display();
        }
    }
    // 获取模板文件夹内的文件夹名称
    protected function find_dir($dirname)
    {
        $arr = array();
        
        if (false === $dir = @opendir($dirname))
            return;
        
        $i = 0;
        
        while (false !== ($tmpname = readdir($dir))) {
            
            if ($tmpname == "." || $tmpname == "..")
                continue;
            
            if ($tmpname) {
                
                $info = pathinfo($tmpname);
                
                $arr[$i]['info'] = require $dirname . '/' . $info['filename'] . "/info.php";
                
                $arr[$i]['info']['code'] = $info['filename'];
            }
            
            $i ++;
        }
        
        return $arr;
    }
    
    // 模板设置
    public function themes()
    {
        $p_themes = $this->find_dir("App/cms/Tpl/computer");
        
        $m_themes = $this->find_dir("App/cms/Tpl/mobile");
        
        $this->assign('p_themes', $p_themes);
        
        $this->assign('m_themes', $m_themes);
        
        $this->display();
    }
    
    // 保存模板配置
    public function Save_themes()
    {
        $setfile = 'App/cms/Conf/config.php';
        
        $a = require $setfile;
        
        $b = $_GET;
        
        $c = array_merge($a, $b);
        
        $settingstr = "<?php \n return array(\n";
        
        foreach ($c as $key => $v) {
            
            $settingstr .= "\t'" . $key . "'=>'" . $v . "',\n";
        }
        
        $settingstr .= "\n);\n?>\n";
        
        if (file_put_contents($setfile, $settingstr) > 0) {
            
            $this->success('修改成功');
            exit;
        } else {
            
            $this->error('修改失败');
            exit;
        }
    }

    /**
     * 注销
     */
    public function logout()
    {
        if (session('?admin')) {
            session('admin', null);
            $this->success('退出成功！', U('Admin/login'));
            exit;
        } else {
            redirect(U('Admin/login'), 0);
            exit();
        }
    }

    /**
     * 登录
     */
    public function login()
    {
        if (session('?admin')) {
            redirect(U('index'), 0);
        } else {
            if (IS_POST) {
                // 登录处理
                if (I('post.user') == '' || I('post.password') == "" || I('post.verifycode') == '') {
                    redirect(U('Admin/login'), 2, '用户名和密码不能为空！');
                }
                if ($_SESSION['authcode'] != md5($_POST['verifycode'])) {
                    // echo $_SESSION['authcode'];
                    // echo "<br />";
                    // echo $_POST['verifycode'];
                    // echo '<br />';
                    // echo md5($_POST['verifycode']);
                    // exit();
                    redirect(U('Admin/login', array(
                        'set' => 'verify_error'
                    )), 0, '验证码错误！');
                }
                $Config = M('Config');
                if ($Config->where(array(
                    'name' => 'site_admin',
                    'value' => I('post.user')
                ))->find()) {
                    if ($Config->where(array(
                        'name' => 'site_password',
                        'value' => md5(I('post.password'))
                    ))->find()) {
                        session('admin', I('post.user'));
                        // 防劫持
                        $brower = $_SERVER['HTTP_USER_AGENT'] . $_SERVER['REMOTE_ADDR'];
                        $brower = md5($brower);
                        session('brower', $brower);
                        $this->success('登录成功！', U('Admin/index'));
                        exit;
                    } else {
                        redirect(U('Admin/login', array(
                            'set' => 'login_error'
                        )), 0, '登录失败！');
                    }
                } else {
                    redirect(U('Admin/login', array(
                        'set' => 'login_error'
                    )), 0, '登录失败！');
                }
            } else {
                	$bgimg = rand(1,8);
		$this->assign('bgimg',$bgimg);
                $this->display();
            }
        }
    }

    /**
     * 验证码
     */
    public function verifycode()
    {
        import('ORG.Util.Image');
        Image::buildImageVerify(4,1,'png','70','40','authcode');
        
    }
    
    // 后台管理类私有上传方法
    private function upload($path)
    {
        import('ORG.Net.UploadFile');
        $upload = new UploadFile();
        $upload->maxSize = 3145728;
        $upload->allowExts = array(
            'jpg',
            'gif',
            'png',
            'jpeg'
        );
        $upload->savePath = './Public/Cms/' . $path . '/';
        if (! $upload->upload()) {
            $this->error($upload->getErrorMsg());
            return false;
        } else {
            $info = $upload->getUploadFileInfo();
            return $info[0]['savename'];
        }
    }

    /**
     * 后台类私有分页方法
     */
    private function getpage($m, $sort = '', $map = '')
    {
        import('ORG.Util.Page');
        if ($map == '') {
            $count = $m->count();
            $Page = new Page($count, 10);
            $Page->setConfig('header', '条记录');
            $show = $Page->show();
            if ($sort == '') {
                $list = $m->limit($Page->firstRow . ',' . $Page->listRows)->select();
            } else {
                $list = $m->order($sort . ' asc')
                    ->limit($Page->firstRow . ',' . $Page->listRows)
                    ->select();
            }
        } else {
            $count = $m->where($map)->count();
            $Page = new Page($count, 10);
            $Page->setConfig('header', '条记录');
            $show = $Page->show();
            if ($sort == '') {
                $list = $m->where($map)
                    ->limit($Page->firstRow . ',' . $Page->listRows)
                    ->select();
            } else {
                $list = $m->order($sort . ' asc')
                    ->where($map)
                    ->limit($Page->firstRow . ',' . $Page->listRows)
                    ->select();
            }
        }
        $listpage[0] = $list;
        $listpage[1] = $show;
        return $listpage;
    }
}